<?
/*

CREATE TABLE `lora` (
  `rid` int(11) NOT NULL,
  `timestamp` int(32) NOT NULL,
  `ip` varchar(256) NOT NULL,
  `eid` varchar(32) NOT NULL,
  `dev_id` varchar(256) NOT NULL,
  `app_id` varchar(256) NOT NULL,
  `Port` int(32) NOT NULL,
  `Cnt` int(32) NOT NULL,
  `gw` varchar(256) NOT NULL,
  `data` varchar(1000) NOT NULL,
  `downlink` varchar(1024) NOT NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

ALTER TABLE `lora`
  ADD PRIMARY KEY (`rid`);

ALTER TABLE `lora`
  MODIFY `rid` int(11) NOT NULL AUTO_INCREMENT, AUTO_INCREMENT=419;
COMMIT;

*/



	error_reporting(0);
	$pdo = new PDO('mysql:host=localhost;dbname=d02c4d81;charset=utf8', "d02c4d81", "XXXXXXXXXX");

	$obj = json_decode(file_get_contents("php://input"));
	
	if ($obj->end_device_ids) // ttn v3
	{	
		$eid 	= strtolower($obj->end_device_ids->dev_eui);
		$devid	= $obj->end_device_ids->device_id;
		$appid	= $obj->end_device_ids->application_ids->application_id;
		$data 	= bin2hex(base64_decode($obj->uplink_message->frm_payload));
		$port 	= $obj->uplink_message->f_port;	
		$cnt 	= $obj->uplink_message->f_cnt;								
		$token 	= $obj->uplink_message->rx_metadata[0]->uplink_token;
		$gw 	= "ttnv3";	
	}
	else if ($obj->rxInfo) // chirp
	{
		$eid 	= $obj->devEUI;
		$data 	= bin2hex(base64_decode($obj->data));
		$devid 	= $obj->deviceName;
		$port 	= $obj->fPort;	
		$cnt 	= $obj->fCnt;		
		$token 	= "";	
		$appid	= $obj->applicationName;
		$gw 	= "chirp";
	}
	if(!$eid) die("No valid ttn/chirpstack communication");

	$statement = $pdo->prepare("SELECT eui FROM afLKeys WHERE eui = :eui");
	$r = $statement->execute(array('eui'=>$eid));
	if(!$statement->fetch()) die($eid." is not a valid Aqua-Scope Dev EUI.");

 	if ($data) // valid uplink packet, no join, tx_confirm, etc.
	{
		$statement = $pdo->prepare("INSERT INTO lora (`timestamp`,`eid`,`dev_id`,`app_id`,`Port`,`Cnt`,`gw`,`data`,`downlink`) VALUES (:timestamp,:eid,:dev_id,:app_id,:Port,:Cnt,:gw,:data,:downlink)");
		$r = $statement->execute(array('timestamp'=>time(),'eid'=>$eid,'dev_id'=>$devid,
		'app_id'=>$appid,'Port'=>$port,'Cnt'=>$cnt,'gw'=>$gw,'data'=>$data,'downlink'=>$token));
	}
?>