<!DOCTYPE html><html><head><title>Aqua-Scope LoRaWAN Demo</title>
</head>
<body>
<?

	const CHIRP_SERVER	= "XXXXX.megasrv.de";
	const CHIRP_USER	= "admin";
	const CHIRP_PWD		= "XXXX";
	const TTN_APIKEY	= "NNSXS.XXXXXXX...........";
	const TTN_APPNAME	= "aqs";
	$pdo = new PDO('mysql:host=localhost;dbname=d02c4d81;charset=utf8', "d02c4d81", "XXXXXXXXXXXXXXX");

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// MYSQL ACCESS AND DISPLAY DATA
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	if(!($eui = strtolower($_GET["dev"]))) die("No dev_id!: ..? dev=YOURDEV");
	else $eui = $_GET["dev"];
	$statement = $pdo->prepare("SELECT * FROM lora WHERE eid = :eui ORDER BY `timestamp` DESC LIMIT 160");
	$r = $statement->execute(array('eui'=>$eui));
	while($row=$statement->fetch())
	{
		if ($row["Port"]==10 or $row["Port"]==16)
			printf("<b>%s</b>@%s: %s<br>", $row["dev_id"],date("Y.m.d H:i:s",$row["timestamp"]),decodeBVSCmd($row["data"])); 		
		else if ($row["Port"]==1)
			printf("<b>%s</b>@%s: %s<br>", $row["dev_id"],date("Y.m.d H:i:s",$row["timestamp"]),decodeAQSCmd($row["data"])); 
		else
			printf("<b>%s</b>@%s: unknown packet from Port %d<br>", $row["dev_id"],date("Y.m.d H:i:s",$row["timestamp"]),$row["Port"]); 		
		if ($row["downlink"]) $downlink = $row["downlink"]; 
		if ($row["gw"]) $gw = $row["gw"]; 	
		if ($row["port"]) $port = $row["port"]; 			
		if ($row["app_id"]) $appid = $row["app_id"]; 
		if ($row["dev_id"]) $devid = $row["dev_id"]; 		
	}
 
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// DOWNLINK PROCESS
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

if ($_POST["cmd"])
{
	switch ($_POST["cmd"])
	{
	case 1:	$pl = sprintf("0101");
			break;
	case 2:	$pl = sprintf("0102");
			break;
	case 3:	$pl = sprintf("0103");
			break;
	case 4:	$pl = sprintf("03");
			break;						
	case 5:	$pl = sprintf("14%02x",$_POST["v1"]);
			break;
	case 6:	$pl = sprintf("04%02x%04x",$_POST["v1"], $_POST["v2"]);
			break;						
	case 7:	$pl = sprintf("0b%02x",$_POST["v1"]);
			break;
	case 8:	$pl = sprintf("09");
			break;			
	case 11:	$pl = sprintf("01%04x",$_POST["v1"]); // BVS Set Heartbeat
			break;
	case 12:	$pl = sprintf("02%02x",$_POST["v1"]); // BVS Set Valve
			break;			
	}
	if ($gw=="ttnv3") //ttnv3
 		sendTTNv3($_POST["eui"],base64_encode(hex2bin($pl)),$_POST["port"],$appid,$devid);
	else // loraserver
		sendChirpStack($_POST["eui"],base64_encode(hex2bin($pl)),$_POST["port"]);
}

//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// DOWNLNK ROUTINES
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

function sendTTNv3($eid,$data,$port,$appid,$devid)
{
	$url = sprintf("https://eu1.cloud.thethings.network/api/v3/as/applications/%s/webhooks/%s/devices/%s/down/push",$appid,TTN_APPNAME,$devid);
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, '{"downlinks":[{"frm_payload":"'.$data.'","f_port":'.$port.',"priority":"NORMAL"}]}');
	curl_setopt($ch, CURLOPT_POST, 1);
		$headers = array();
		$headers[] = 'Content-Type: application/json';
		$headers[] = 'Accept: application/json';
		$headers[] = 'Authorization: Bearer '.TTN_APIKEY;
	curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
	$r = curl_exec($ch);
	if(strlen($r)>0) var_dump($r);		
	else printf("<br><font color='green'>Sent via ttn3 to eui: %s, data: '%s' (HEX: %s)</font><br><br>",$devid,base64_encode(hex2bin($pl)),$pl);
}

function sendChirpStack($eid,$data,$port) {
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, 'http://'.CHIRP_SERVER.':8080/api/internal/login');
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, "{  \n   \"password\": \"".CHIRP_PWD."\",  \n   \"username\": \"".CHIRP_USER."\"  \n }");
	curl_setopt($ch, CURLOPT_POST, 1);	
	$headers = array();
	$headers[] = 'Content-Type: application/json';
	$headers[] = 'Accept: application/json';
	curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);	
	$result = json_decode(curl_exec($ch));
	curl_close($ch);
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, 'http://'.CHIRP_SERVER.':8080/api/devices/'.$eid.'/queue');
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, "{\"deviceQueueItem\": {\"confirmed\": false, \"data\": \"".$data."\", \"devEUI\": \"".$eid."\", \"fCnt\": 1, \"fPort\": ".$port.", \"jsonObject\": \"\"  \n   }  \n }");
	curl_setopt($ch, CURLOPT_POST, 1);
	$headers = array();
	$headers[] = 'Content-Type: application/json';
	$headers[] = 'Accept: application/json';
	$headers[] = 'Grpc-Metadata-Authorization: Bearer '.$result->jwt;
	curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
	$js = json_decode(curl_exec($ch));
	printf("<br><font color='green'>Sent via chirp to eui: %s, Data: '%s', Status: %s </font><br><br>",$eid,$data,$js->fCnt); 
	curl_close($ch);
	return $js->fCnt;
}


//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// DECODE/DISPLAY ROUTINES
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

function decodeBVSCmd($raw)
{
	$v = str_split ($raw, 2);
	$temperature = intVal($v[2],16)*256+intVal($v[3],16);
	$status = "";
	$alarm = intVal($v[0],16);
	if ($alarm & 0x02) $status .= ", Flood Alarm";
	if ($alarm & 0x04) $status .= ", Heart Beat";
	if ($alarm & 0x08) $status .= ", Temperature Alarm";
	if ($alarm & 0x20) $status .= ", Valve Closed";
	if ($alarm & 0x40) $status .= ", Valve Open";				
	return sprintf("Battery %d &#37;, Temperature: %0.1f &#8451;, Firmware %s.%s on HW %s%s",
	intVal($v[1],16),$temperature/10,$v[4],$v[5],$v[6], $status);
}


function decodeAQSCmd($raw)
{
	$v = str_split ($raw, 2);
	$ptr=0;
	$out = "";
	//var_dump($raw);
	while ($v[$ptr])
	{
		if(strlen($out) > 0) $out.= " | ";
		switch(intVal($v[$ptr] ,16)) 
		{
			case 0x03: 
				$out .= sprintf("Version: HW = %d, firmware built: %d",intVal($v[++$ptr],16),intVal($v[++$ptr].$v[++$ptr].$v[++$ptr].$v[++$ptr],16));
				break;
			case 0x04: 
				$out .= sprintf("Configuration Parameter: %d = 0x%x%x",intVal($v[++$ptr],16),intVal($v[++$ptr],16),intVal($v[++$ptr],16));
				break;
			case 0x06: 
				$out .= getSensorType(intVal($v[++$ptr],16), $v[++$ptr].$v[++$ptr]);
				break;
			case 0x07: 
				$out .= sprintf("Status: %s",getWaterstate(intVal($v[++$ptr],16), $v[++$ptr].$v[++$ptr], $v[++$ptr].$v[++$ptr]));
				break;
			case 0x08: 
				$out .= getLogInfo(intVal($v[++$ptr],16), intVal($v[++$ptr].$v[++$ptr],16),intVal($v[++$ptr].$v[++$ptr],16) );
				break;				
			case 0x09: 
				$out .= sprintf("Calibration %s ",getCalibrationStatus(intVal($v[++$ptr],16),$v[++$ptr].$v[++$ptr],$v[++$ptr].$v[++$ptr])); 
				break;				
			case 0x0b:
				$out .= sprintf("Alarm %s %s, value = 0x%s%s",intVal($v[++$ptr] ,16) ? "Active " : "Cleared " ,
						getAlarmType(intVal($v[++$ptr],16)), $v[++$ptr],$v[++$ptr]);
				break;
			default:
				$out .= sprintf("Unknown Command 0x%s", $v[++$ptr]);
		}
		$ptr++;
	}
return $out;
}

function getLogInfo($v1, $v2, $v3)
{
	switch ($v1)
	{
		case 1: return sprintf("Device in Factory Default");	
		case 2: return sprintf("Pressure Sensor Lost");
		case 3: return sprintf("Pressure Sensor Reconnected");		
		case 4: return sprintf("Quick Calibration Finished: P = %d mBar, N = %d mBar",$v2, $v3);		
		case 5: return sprintf("Standard Calibration Finished: P = %d mBar, PRV %s present, Tank %s present",$v2, $v3 & 0x01 ? "": "not", $v3 & 0x02 ? "": "not");	
		case 6: return sprintf("Long Term Calibration Finished: P = %d mBar, N = %d mBar",$v2, $v3);						
		case 7: return sprintf("%s",$v2 ? "PRV present":"No PRV present");				
	}
}

function getWaterstate($d, $v1, $v2)
{
	switch ($d)
	{
		case 0x01: return sprintf("Water Flow Finished: %d l in %d sec. ",intVal($v2,16), intVal($v1,16));
		case 0x02: return sprintf("PipeCheck Complete - no Alarm  Decay %d mBar End Pressure %d mBar",intVal($v1,16), intVal($v2,16));
		case 0x03: return sprintf("PipeCheck Complete - Alarm ! Loss %d mLiter/h, Orifize %d m above sensor",intVal($v1,16), intVal($v2,16));
		case 0x04: return sprintf("PipeCheck Incomplete (regular water take)");
		case 0x05: return sprintf("PipeCheck Incomplete (warm water heat)");
		case 0x08: return sprintf("PipeCheck Started ");								
		default:   return sprintf("Unknown State %d with value1 %d and value 2 %d ",$d,intVal($v2,16), intVal($v1,16));
	}
}


function getCalibrationStatus($d,$v1,$v2)
{
	$s1 = intval($v1,16);
	$s2 = intval($v2,16);	
	switch ($d)
	{
		case 0x03: return sprintf("pending ");
		case 0x04: return sprintf("failed");		
		case 0x05: return sprintf("succeessful%s, Pressure = %d mbar",$s1==2 ? ", PRV detected":"",$s2);
		case 0x06: return sprintf("completed, Pressure = %d mbar");
		default:   return sprintf("unknown state 0x%x",$d);
	}
}

function getSensorType($d, $v)
{
	switch ($d)
	{
		case 0x01: return sprintf("Temperature: %.1f Celsius",intVal($v,16)/10);
		case 0x03: return sprintf("Uptime %d",intVal($v,16));		
		case 0x10: return sprintf("Water Pressure: %.d mBar",intVal($v,16));
		case 0x11: return sprintf("Water Consumption %d Liter",intVal($v,16));
		default:   return sprintf("Unknown Sensor %d with value %d ",$d,intVal($v,16));
	}
}

function getAlarmType($t)
{
	switch ($t)
	{
		case 0x00: return "All";
		case 0x01: return "Flow Sensor";
		case 0x02: return "Long Water Flow";	
		case 0x03: return "Heavy Water Loss";
		case 0x04: return "Jamming Toilet Flap";
		case 0x05: return "Overpressure";
		case 0x06: return "Max. Pressure reached";			
 		case 0x07: return "Drip";	
 		case 0x08: return "Pipe-Check";	 				
		default:   return sprintf("Unknown Alarm %d ",$t);
	}
}
?>

<hr>
<form method = "POST"> 
<input type="hidden" name="downlink" id="downlink" 		value = "<? echo $downlink ?>" maxlength="10">
<input type="hidden" name="gw" id="gw" 					value = "<? echo $gw?>" maxlength="10">
<input type="hidden" name="eui" id="eui" 				value = "<? echo $eui?>" maxlength="10">
<table>
<tr><td>
	<select name="cmd" id = "cmd" size="6">
	<option value="11"> BVS - Set Heartbeat</option>
	<option value="12"> BVS - Set Valve </option>	
	<option value="1"> AQS - Reboot </option>
	<option value="2"> AQS - Reset </option>
	<option value="3"> AQS - PipeCheck Start </option>	
	<option value="4"> AQS - Version Get</option>
	<option value="5"> AQS - Configuration Get </option>
	<option value="6"> AQS - Configuration Set </option>	
	<option value="7"> AQS - Clear Alarm </option>
	<option value="8"> AQS - Calibration </option>	
	</select>
</td><td>
	Value 1 (if needed): <br>
	<input type="text" name="v1" id="v1" maxlength="10"> <br>
	Value 2 (if needed): <br>
	<input type="text" name="v2" id="v2" maxlength="10"> <br>
</td><td>
	Port: <br>
	<input type="text" name="port" id="port" maxlength="5" size="3"> <br><br>
	<button type="submit">Sent</button>
</td> </tr></table>
</form>
</body>
</html>

